﻿(function () {

    "use strict";



    //replace with your own login data

    var Office365AccountDetails = {

        username: 'username@yourdomain.onmicrosoft.com ',

        password: 'password',

        SPOhost: 'https://yourdomain.sharepoint.com'

    };



    var xmlDoc;

    var newsItems = new WinJS.Binding.List();

    //create a new helper object that uses the C# Windows Runtime Component class to sign in to Office 365 and send queries

    var wrapper = new Office365AuthHelperRT.Office365AuthHelperRT();





    function signin() {

        return wrapper.signin(Office365AccountDetails.username,

                              Office365AccountDetails.password,

                              Office365AccountDetails.SPOhost);

    }



    function getNewsItems() {

        //create SOAP Action, Message, and url to send to. Replace with your own

        var soapAction = "http://schemas.microsoft.com/sharepoint/soap/GetListItems";

        var soapMessage = "<soap:Envelope xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance' xmlns:xsd='http://www.w3.org/2001/XMLSchema' xmlns:soap='http://schemas.xmlsoap.org/soap/envelope/'>"+

            "<soap:Body><GetListItems xmlns='http://schemas.microsoft.com/sharepoint/soap/'>"+

            "<listName>Announcements</listName>"+

            "<viewName></viewName><query></query><viewFields>"+

            "<ViewFields><FieldRef Name='Title' /><FieldRef Name='ID' /><FieldRef Name='Body' /><FieldRef Name='Created' /></ViewFields>"+

            "</viewFields><rowLimit>0</rowLimit><queryOptions><QueryOptions></QueryOptions></queryOptions></GetListItems></soap:Body></soap:Envelope>";

        var soapUrl = "https://yourdomain.sharepoint.com/_vti_bin/Lists.asmx";

        //once we've signed in successfully, load items

        signin().then(function () {

            wrapper.executeQuery(soapUrl, soapMessage, soapAction).done(function (results) {

                xmlDoc = new Windows.Data.Xml.Dom.XmlDocument();

                xmlDoc.loadXml(results);

                getItemsFromXml();

                WinJS.Navigation.navigate("/pages/split/split.html");

            });

        });

        return newsItems;

    }



    function getItemsFromXml() {

        //items are returned within individual z:row nodes

        xmlDoc.getElementsByTagName("z:row").forEach(function (node) {

            newsItems.push({

                group: { title: 'Announcements' },

                key: node.attributes.getNamedItem("ows_UniqueId").innerText,

                title: node.attributes.getNamedItem("ows_Title").innerText,

                date: node.attributes.getNamedItem("ows_Created").innerText,

                content: node.attributes.getNamedItem("ows_Body").innerText,

            });

        });

    }

    





    // functions below were mostly auto-generated. 



    // Get a reference for an item, using the group key and item title as a

    // unique reference to the item that can be easily serialized.

    function getItemReference(item) {

        return [item.group.key, item.title];

    }



    function resolveGroupReference(key) {

        for (var i = 0; i < groupedItems.groups.length; i++) {

            if (groupedItems.groups.getAt(i).key === key) {

                return groupedItems.groups.getAt(i);

            }

        }

    }



    function resolveItemReference(reference) {

        for (var i = 0; i < groupedItems.length; i++) {

            var item = groupedItems.getAt(i);

            if (item.group.key === reference[0] && item.title === reference[1]) {

                return item;

            }

        }

    }



    // This function returns a WinJS.Binding.List containing only the items

    // that belong to the provided group.

    function getItemsFromGroup(group) {

        return list.createFiltered(function (item) { return item.group.key === group.key; });

    }



    var list = getNewsItems();





    var groupedItems = list.createGrouped(

        function groupKeySelector(item) { return item.group.key; },

        function groupDataSelector(item) { return item.group; }

    );



  



    WinJS.Namespace.define("Data", {

        items: groupedItems,

        groups: groupedItems.groups,

        getItemsFromGroup: getItemsFromGroup,

        getItemReference: getItemReference,

        resolveGroupReference: resolveGroupReference,

        resolveItemReference: resolveItemReference

    });

})();

